/***************************************************************************
 $RCSfile: editpayee.h,v $
                             -------------------
    cvs         : $Id: editpayee.h,v 1.1 2005/02/23 02:15:33 aquamaniac Exp $
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef AQBANKING_KDE_EDITPAYEE_H
#define AQBANKING_KDE_EDITPAYEE_H

extern "C" {
  // workaround
#include <aqbanking/country.h>
}


#include "editpayee.ui.h"
#include <aqbanking/banking.h>
#include <gwenhywfar/db.h>


class Payee;
class KBanking;


class EditPayee : public EditPayeeUi {
  Q_OBJECT
public:
  EditPayee(KBanking *kb,
            Payee *payee,
            bool readOnly,
            QWidget* parent=0,
            const char* name=0,
            bool modal=FALSE,
            WFlags fl=0);
  ~EditPayee();

public slots:
  void accept();
  void slotAddRule();
  void slotDelRule();
  void slotEditRule();

private:
  KBanking *_app;
  Payee *_payee;
  bool _readOnly;
  AB_COUNTRY_CONSTLIST2 *_countries;
  GWEN_DB_NODE *_rules;

  void payeeToGui();
  void guiToPayee();
  void updateRules();
};





#endif

