/***************************************************************************
 $RCSfile: transferview.h,v $
                             -------------------
    cvs         : $Id: transferview.h,v 1.7 2005/06/13 20:00:08 aquamaniac Exp $
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/



#ifndef KBANKING_TRANSFERVIEW_H
#define KBANKING_TRANSFERVIEW_H

#include "transferview.ui.h"

#include <qwidget.h>


class TransferView;


#include "transferlist.h"
#include "kbanking.h"


class TransferView: public TransferViewUi {
  Q_OBJECT
public:
  TransferView(KBanking *app,
               QWidget* parent=0, const char* name=0, WFlags fl=0);
  ~TransferView();

  bool init();
  bool fini();

protected:
  //void resizeEvent(QResizeEvent *e);
  void closeEvent(QCloseEvent *e);

private:
  KBanking *_app;
  TransferListView *_xaList;

  AB_JOB *_newTransferJob(Transfer::TransferType tt,
                          RefPointer<Transfer> tmpl=0);
  void _newTransfer(RefPointer<Transfer> tmpl=0);
  void _newDebitNote(RefPointer<Transfer> tmpl=0);
  void _newEuTransfer(RefPointer<Transfer> tmpl=0);

public slots:
  void slotUpdated();
  void slotDetails();
  void slotNewTransfer();
  void slotNewDebitNote();
  void slotNewEuTransfer();
  void slotRepeat();
};










#endif /* KBANKING_TRANSFERVIEW_H */



